Predict the Winner一个动态规划的问题解法详解

来源:互联网 发布:淘宝装修神器书本 编辑:程序博客网 时间:2024/06/07 11:03

问题详见: Predict the Winner

题目是给出一个非负整数数组,按照他的游戏规则预测玩家1能不能赢。题目描述如下:
      Given an array of scores that are non-negative integers. Player 1 picks one of the numbers from either end of the array followed by the player 2 and then player 1 and so on. Each time a player picks a number, that number will not be available for the next player. This continues until all the scores have been chosen. The player with the maximum score wins.
      Given an array of scores, predict whether player 1 is the winner. You can assume each player plays to maximize his score.

Example 1:

Input: [1, 5, 2]
Output: False
Explanation:
      Initially, player 1 can choose between 1 and 2.
      If he chooses 2 (or 1), then player 2 can choose from 1 (or 2) and 5. If player 2 chooses 5, then player 1 will be left with 1 (or 2).
      So, final score of player 1 is 1 + 2 = 3, and player 2 is 5.
      Hence, player 1 will never be the winner and you need to return False.

Example 2:

Input: [1, 5, 233, 7]
Output: True
Explanation:
      Player 1 first chooses 1. Then player 2 have to choose between 5 and 7. No matter which number player 2 choose, player 1 can choose 233.
      Finally, player 1 has more score (234) than player 2 (12), so you need to return True representing player1 can win.

Note:

  1. 1 <= length of the array <= 20.
  2. Any scores in the given array are non-negative integers and will not exceed 10,000,000.
  3. If the scores of both players are equal, then player 1 is still the winner.

解题思路:

      由于题目中的玩法是玩家从数组两端选择然后记入自己的总分中,然后将该数从数组中移除,交由下为玩家选择。所以我们每记录一个分数我们都得到一个子数组[i, j],我们记做A[i, j]。在给定一个子数组A[i, j]时,玩家1可以选择A[i]或者A[j],然后变成数组A[i+1, j]或者A[i, j-1]交由玩家2选择。然后我们能得到动态规划方程dp(i,j)=max(nums[j]dp(i,j1),nums[i]dp(i+1,j)),其中dp(i,j)表示子数组(i,j)供选择时玩家1和玩家2的总分数差值,算法复杂度为O(n2)。具体算法如下:

class Solution {public:    bool PredictTheWinner(vector<int>& nums) {        int n = nums.size();        vector<vector<int>> dp(n, vector<int>(n));        for (int i = 0; i < n; i++) dp[i][i] = nums[i];        for (int i = 1; i < n; i++) {            for (int j = 0; j+i < n; j++) {                dp[j][j+i] = max(nums[j+i]-dp[j][j+i-1], nums[j]-dp[j+1][j+i]);            }        }        return dp[0][n-1] >= 0;    }};

其提交运行结果如下:
DP

0 0
原创粉丝点击